unit ExtColorMemo;

interface

uses
 Windows, 
 Messages, 
 Classes,
 Graphics,
 ColMemo;

type
 TExtColorMemo = class(TColorMemo)
 private
   { Private declarations }
   FGutterSize : Word;
 protected
   { Protected declarations }
   procedure CreateWnd; override;
   procedure WMPaint( var Msg : TWMPaint ); message wm_Paint;
 public
   { Public declarations }
   constructor Create(AOwner : TComponent); override;
   destructor Destroy; override;
 published
   { Published properties and events }
   property GutterSize : word read FGutterSize write FGutterSize;
 end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TExtColorMemo]);
end;

procedure TExtColorMemo.WMPaint( var Msg : TWMPaint );
begin
 inherited;

  { Paint the gutter in Silver. }
  with Canvas do begin
    Brush.Color := clSilver;
    Pen.Color := clSilver;
    Rectangle(0, 0, FGutterSize, Height);
  end;
end;

destructor TExtColorMemo.Destroy;
begin
  inherited Destroy;
end;

constructor TExtColorMemo.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
end;

procedure TExtColorMemo.CreateWnd;
var 
  R : TRect;
begin
  inherited;

  R := RECT( FGutterSize, 0, Self.Width, Self.Height);
  SendMessage(Handle,EM_SETRECT,0,Integer(@R));
end;

end.



